using System;
using AllocsFixes.PersistentData;
using System.Collections.Generic;

namespace CoppisAdditions
{
	public class ForceChunkReload
    {
        public static void exec(Dictionary<long, Chunk> dic)
        {
            Dictionary<String, List<Chunk>> players = new Dictionary<String, List<Chunk>>();
            foreach (long key in dic.Keys)
            {
                Chunk chunk;
                dic.TryGetValue(key, out chunk);
                int x = chunk.GetWorldPos().x;
                int z = chunk.GetWorldPos().z;

                foreach (string steamid in GameManager.Instance.persistentPlayers.Players.Keys)
                {
                    ClientInfo ci1 = ConsoleHelper.ParseParamIdOrName(steamid);
                    if (ci1 != null)
                    {
                        EntityPlayer ep1 = GameManager.Instance.World.Players.dict[ci1.entityId];
                        if (Math.Abs(ep1.GetPosition().x - x) < 200 && Math.Abs(ep1.GetPosition().z - z) < 200)
                        {
                            List <Chunk> list;
                            if (!players.ContainsKey(steamid))
                            {
                                list = new List<Chunk>();
                                players.Add(steamid, list);
                            }
                            players.TryGetValue(steamid, out list);

                            list.Add(chunk);

                            players.Remove(steamid);
                            players.Add(steamid, list);
                        }
                    }
                }
            }

            foreach (String steamid in players.Keys)
            {
                ClientInfo ci1 = ConsoleHelper.ParseParamIdOrName(steamid);
                if (ci1 != null)
                {
                    List<Chunk> list;
                    players.TryGetValue(steamid, out list);
                    if (list != null)
                    {
                        foreach (Chunk chunk in list)
                        {
                            ci1.SendPackage(new NetPackageChunkRemove(chunk.Key));
                        }
                        foreach (Chunk chunk in list)
                        {
                            ci1.SendPackage(new NetPackageChunk(chunk));
                        }
                    }
                }
            }

            //MAKE TWITCE TO AVOID GLITCHES
            foreach (String steamid in players.Keys)
            {
                ClientInfo ci1 = ConsoleHelper.ParseParamIdOrName(steamid);
                if (ci1 != null)
                {
                    List<Chunk> list;
                    players.TryGetValue(steamid, out list);
                    if (list != null)
                    {
                        foreach (Chunk chunk in list)
                        {
                            ci1.SendPackage(new NetPackageChunkRemove(chunk.Key));
                        }
                        foreach (Chunk chunk in list)
                        {
                            ci1.SendPackage(new NetPackageChunk(chunk));
                        }
                    }
                }
            }
        }

        public static void exec(Dictionary<long, Chunk> dic, ClientInfo ci1)
        {
            if (ci1 != null)
            {
                foreach (long key in dic.Keys)
                {
                    Chunk c;
                    if (dic.TryGetValue(key, out c))
                    {
                        ci1.SendPackage(new NetPackageChunkRemove(c.Key));
                    }
                }
                foreach (long key in dic.Keys)
                {
                    Chunk c;
                    if (dic.TryGetValue(key, out c))
                    {
                        ci1.SendPackage(new NetPackageChunk(c));

                    }
                }
            }
        }

    }
}
